;|									;;
	TLEADER 2							;;
	by: Andrea Andreetti	2008-09-20				;;
	Allow user to create LEADER only by crossing cursor over a TEXT	;;
									|;
(princ "\nTleader2 v.2.0		by: Andrea Andreetti")

(vl-load-com)

;;VARi
;|						;
	CAPTURE DES VARIABLES AUTOCAD		;
						|;
(defun GEN_VARI_current ()
(setq
GEN_VARI_clayer		(getvar "clayer")	;;Calque courrant
GEN_VARI_cecolor	(getvar "cecolor")	;;Couleur courant
GEN_VARI_celtype	(getvar "celtype")	;;ltype courant
GEN_VARI_ltscale	(getvar "ltscale")	;;ltscale courant
GEN_VARI_celtscale	(getvar "celtscale")	;;celtscale courant
GEN_VARI_tilemode	(getvar "tilemode")	;;tilemode courant
GEN_VARI_dimstyle	(getvar "dimstyle")	;;dimstyle courant
GEN_VARI_dimscale	(getvar "dimscale")	;;dimstyle courant
);;setq
);;defun
;;***********************************************




;;;;;;;;;;;;;;;;;;;;;;DEGRE  RADIANS
(defun dtr (a)
  (* pi (/ a 180.0))
)

;;;;;;;;;;;;;;;;;;;;;;RADIANS  DEGRE
(defun rtd (a)
  (/ (* a 180) pi)
)



;;UCS conversion
(defun gins (val ent)
(trans (cdr (assoc val ent)) e1 1)
)








;;SET XDATA
(defun TL_put_Text_Xdata (enty APPname Xdta / ent type1 Valeur)
      (vl-load-com) 
      (setq ent (vlax-ename->vla-object enty)) 
      (setq type1   (vlax-make-safearray vlax-vbInteger (cons 0 1)) 
            Valeur  (vlax-make-safearray vlax-vbVariant (cons 0 1))) 
      (vlax-safearray-put-element type1   0 1001) 
      (vlax-safearray-put-element valeur 0 APPname)
      (vlax-safearray-put-element type1   1 1000) 
      (vlax-safearray-put-element valeur 1 (vl-princ-to-string Xdta))
      (setq type1   (vlax-make-variant type1) 
            valeur (vlax-make-variant valeur)) 
      (vla-setxdata ent type1 valeur)
)







;;GET XDATA
(defun TL_get_Text_Xdata (item xdta)
  (setq ent (vlax-ename->vla-object item))
  (vla-getxdata ent xdta 'type1 'valeur)
  (if valeur
  (setq pte (vlax-variant-value (nth 1 (vlax-safearray->list valeur))))
)
)









;;
(defun go_run_text ()  
(setq e1 ent_sel1)
(setq ucszdir (trans '(0 0 1) 1 0 T))  
(setq _Trota (angle '(0 0 0) (trans (getvar "ucsxdir") 0 '(0.0 0.0 1.0))))
(setq _Trotat  (cdr (assoc 50 ent_sel2)))	;;Rotation
(setq _Thandle (cdr (assoc 5 ent_sel2)))	;;Handle
(setq _Tjust (cdr (assoc 71 ent_sel2)))		;;Justification
(setq _Trota (- _Trotat _Trota))

(setq _Tinse (gins 10 ent_sel2))		;;Insertion (50.724 33.9705 0.0)
(setq _Thaut (cdr (assoc 40 ent_sel2)))		;;Hauteur du texte
(setq _Tlong (car (cadr (textbox ent_sel2))))	;;Longueur

;;Put XDATA to Text
(setq T_xData (vl-princ-to-string (list (rtos (nth 0 _Tinse) 2 8)(rtos (nth 1 _Tinse) 2 8))))
(TL_put_Text_Xdata e1 "TLeader" T_xData)
  
(setq #pmg (polar _Tinse (+ _Trota (dtr 90)) (/ _Thaut 2)))
(setq #pmg (polar #pmg (- _Trota (dtr 180)) (/ _Thaut 2)))
(setq #pmd (polar #pmg _Trota (+ _Tlong _Thaut)))

(setq #pmgg (polar #pmg (- _Trota (dtr 180)) (/ _Thaut 2)))
(setq #pmdd (polar #pmd _Trota (/ _Thaut 2)))

(setq #phg (polar #pmg (+ _Trota (dtr 90)) (/ _Thaut 2)))
(setq #pbg (polar #pmg (- _Trota (dtr 90)) (/ _Thaut 2)))

(setq #phd (polar #pmd (+ _Trota (dtr 90)) (/ _Thaut 2)))
(setq #pbd (polar #pmd (- _Trota (dtr 90)) (/ _Thaut 2)))

(setq #ihg (polar #pmgg (+ _Trota (dtr 90)) (/ _Thaut 2)))
(setq #ibg (polar #pmgg (- _Trota (dtr 90)) (/ _Thaut 2)))

(setq #ihd (polar #pmdd (+ _Trota (dtr 90)) (/ _Thaut 2)))
(setq #ibd (polar #pmdd (- _Trota (dtr 90)) (/ _Thaut 2)))
;(vl-cmdf "_point" #pmg "_point" #pmd)

  
(setq
pt_1 nil
#ELP nil
barrGflag nil
barrDflag nil
BarrG nil
BarrD nil
pickmode nil
)
  
(while (not #ELP)
(simulPreviewDT)
(if (/= pickmode 3)
    (redraw)
(createDTleader)  
)
)  

)




 










;
;
;
;
;		MTEXT			;
(defun go_run_Mtext ()

;;;  (defun gins (val ent)
;;;(trans (cdr (assoc val ent)) e1 1)
;;;)
;;(setq e1 (car ent_sel1))
(setq e1 ent_sel1)
(setq AdR (cdr (assoc 50 ent_sel2)))
(setq ucszdir (trans '(0 0 1) 1 0 T))
  
		(setq hdt (/ (setq htt (cdr (assoc 40 ent_sel2))) 2))	;Hauteur Du Texte / 2
		(setq LHo (cdr (assoc 42 ent_sel2)))		;Longueur Horizontale
		(setq HVe (cdr (assoc 43 ent_sel2)))		;Hauteur Verticale
		(setq _Tjust (cdr (assoc 71 ent_sel2)))		;Mthode d'insertion
                ;(setq phg (cdr (assoc 10 ent_sel2)))		;Point 10
  		(setq _Thandle (cdr (assoc 5 ent_sel2)))
  		(setq phg (gins 10 ent_sel2))



;;Put XDATA to MText
(setq T_xData (list (rtos (nth 0 phg) 2 8)(rtos (nth 1 phg) 2 8)))
(TL_put_Text_Xdata e1 "TLeader" T_xData)

  

  
;point Haut Gauche
		(if (eq _Tjust 1)
		  (setq phg (gins 10 ent_sel2))
		)
		(if (eq _Tjust 2)
		  (setq	phg (polar phg
				   (- AdR (dtr 180))
				   (/ LHo 2)
			    )
		  )
		)
		(if (eq _Tjust 3)
		  (setq	phg (polar phg
				   (- AdR (dtr 180))
				   LHo
			    )
		  )
		)
		(if (eq _Tjust 4)
		  (setq	phg (polar phg
				   (+ AdR (dtr 90))
				   (/ HVe 2)
			    )
		  )
		)
		(if (eq  _Tjust 5)
		  (progn
		    (setq phgt (polar phg
				      (+ AdR (dtr 90))
				      (/ HVe 2)
			       )
		    )
		    (setq phg (polar phgt (- AdR (dtr 180)) (/ LHo 2)))
		  )
		)

		(if (eq  _Tjust 6)
		  (progn
		    (setq phgt (polar phg
				      (+ AdR (dtr 90))
				      (/ HVe 2)
			       )
		    )
		    (setq phg (polar phgt (- AdR (dtr 180)) LHo))
		  )
		)

		(if (eq  _Tjust 7)
		  (setq	phg (polar phg
				   (+ AdR (dtr 90))
				   HVe
			    )
		  )
		)

		(if (eq  _Tjust 8)
		  (progn
		    (setq phgt (polar phg
				      (+ AdR (dtr 90))
				      HVe
			       )
		    )
		    (setq phg (polar phgt (- AdR (dtr 180)) (/ LHo 2)))
		  )
		)

		(if (eq  _Tjust 9)
		  (progn
		    (setq phgt (polar phg
				      (+ AdR (dtr 90))
				      HVe
			       )
		    )
		    (setq phg (polar phgt (- AdR (dtr 180)) LHo))
		  )
		)

		(setq #phg (polar phg (- AdR (dtr 180)) hdt))
					;point Haut Gauche
		(setq #pbg (polar #phg (- AdR (dtr 90)) HVe))
					;point Bas Gauche
		(setq #pbd (polar #pbg AdR (+ LHo (* 2 hdt))))
					;point Bas Droit
		(setq #phd (polar #phg AdR (+ LHo (* 2 hdt))))
					;point Haut Droit

  ;(vl-cmdf "_.pline" #phg #phd #pbd #pbg #phg "")

(setq #pmg  (polar #pbg (angle #pbg #phg) (/ (distance #pbg #phg) 2)))
(setq #pmgg (polar #pmg (angle #phd #phg) (* hdt 2)))
  
(setq #pmd  (polar #pbd (angle #pbd #phd) (/ (distance #pbd #phd) 2)))
(setq #pmdd (polar #pmd (angle #phg #phd) (* hdt 2)))    

(setq #ihg (polar #phg (angle #phd #phg) (* hdt 2)))
(setq #ihd (polar #phd (angle #phg #phd) (* hdt 2)))
(setq #ibg (polar #pbg (angle #pbd #pbg) (* hdt 2)))
(setq #ibd (polar #pbd (angle #pbg #pbd) (* hdt 2)))
  
(setq
pt_1 nil
#ELP nil
barrGflag nil
barrDflag nil
BarrG nil
BarrD nil
)


(while (not #ELP)
(simulPreviewMT)
(if (/= pickmode 3)
  (progn
    ;(alert "Tleader Termin")
    (redraw)
    )
(createMTleader)  
)
)  

)







;;222222222222222

(defun simulPreviewDT ()

(setq VS2 (/ (getvar "VIEWSIZE") 30))  
  (while (= (car (setq grr (grread T 4))) 5)
(setq #ELP (car (cdr grr)))

    
(foreach p TEXTpL
    (if (and
	  (< (distance p #ELP) VS2)
	  (/= pt p)
	  )
	 (progn
	   (setq pickmode nil
		 grr nil)
	   (Tleader2_go)
	 )
        
      (progn   

  
  (redraw)
  (if (< (distance #ELP #pmg)(distance #ELP #pmd))

    ;;cot Gauche
    (progn
      (setq inter "G")
      (setq #SLP #pmgg)
      ;;MTEXT avec LINE
	  (grdraw #pmg #pmgg 141 1)
	  (if (inters #pmg #ihg #pmgg #ELP);(inters #pmg #phg #pmgg #ELP)
	      (progn		
		(grdraw #pmgg #ihg 141 1)
		(setq #SLP #ihg)
		(setq inter "HG")
	      )
	  )
	  (if (inters #pmg #ibg #pmgg #ELP)
	      (progn	
		(grdraw #pmgg #ibg 141 1)
		(setq #SLP #ibg)
		(setq inter "BG")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 141 1)
	  )
    ;;cot Droit
    (progn
      (setq inter "D")
      (setq #SLP #pmdd)
      ;;MTEXT avec LINE
	  (grdraw #pmd #pmdd 243 1)
	  (if (inters #pmd #ihd #pmdd #ELP)
	      (progn		
		(grdraw #pmdd #ihd 243 1)
		(setq #SLP #ihd)
		(setq inter "HD")
	      )
	  )
	  (if (inters #pmd #ibd #pmdd #ELP)
	      (progn	
		(grdraw #pmdd #ibd 243 1)
		(setq #SLP #ibd)
		(setq inter "BD")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 243 1)
	  )


    )

)
)
)
)

(setq pickmode (car grr))

  )











(defun simulPreviewMT ()
  (if (> hve (* htt 2))
      (setq DrawBar nil)
      (setq DrawBar T)
    )  
  (setq VS2 (/ (getvar "VIEWSIZE") 30)) 
(while (= (car (setq grr (grread T 4))) 5)

 (setq #ELP (car (cdr grr)))

    
(foreach p TEXTpL
    (if (and
	  (< (distance p #ELP) VS2)
	  (/= pt p)
	  )
	 (progn
	   (setq pickmode nil
		 grr nil)
	   (Tleader2_go)
	 )
        
      (progn   

  
  (redraw)

  (if (< (distance #ELP #pmg)(distance #ELP #pmd))

    ;;cot Gauche
    (progn
      (setq inter "G")
      (setq #SLP #pmgg)
      
      ;;MTEXT avec LINE
      (if (eq Lstyle 0)	  
	  (progn
	  (if (not DrawBar)
	    (progn
	      (setq DrawBar nil)
	  (setq barrG (list #phg #pmg #pmgg #pmg #pbg ""))
	  (grdraw #pbg #phg 141 1)
	  ))
	  
	  (grdraw #pmg #pmgg 141 1)
	  (if (inters #pmg (polar #pmgg (angle #pmg #phg) (distance #pmg #phg)) #pmgg #ELP)
	      (progn		
		(grdraw #pmgg #ihg 141 1)
		(setq #SLP #ihg)
		(setq inter "HG")
	      )
	  )
	  (if (inters #pmg (polar #pmgg (angle #pmg #pbg) (distance #pmg #pbg)) #pmgg #ELP)
	      (progn	
		(grdraw #pmgg #ibg 141 1)
		(setq #SLP #ibg)
		(setq inter "BG")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 141 1)
	  ))
      ;;MTEXT avec ACCOLADE
      (if (eq Lstyle 1)	  
	  (progn
	    
	  (if (not DrawBar)
	    (progn
	  (setq #acc1a (polar #phg (angle #phd #phg) hdt))
	  (setq #acc1a (polar #acc1a (angle #phg #pbg) hdt))
	  (setq #acc2a (polar #acc1a (angle #phg #pbg) (- (/ (distance #phd #pbd) 2) (* hdt 2))))
	  (setq #acc2b (polar #acc2a (angle #phg #pbg) (* hdt 2)))
	  (setq #acc1b (polar #acc2b (angle #phg #pbg) (- (/ (distance #phd #pbd) 2) (* hdt 2))))
	  
	  (setq barrG (list #phg #acc1a #acc2a #pmgg #acc2b #acc1b #pbg ""))
	  (grdraw #phg #acc1a 141 1)
	  (grdraw #acc1a #acc2a 141 1)
	  (grdraw #acc2a #pmgg 141 1)
	  (grdraw #pmgg #acc2b 141 1)
	  (grdraw #acc2b #acc1b 141 1)
	  (grdraw #acc1b #pbg 141 1)
	   )
	    (grdraw #pmg #pmgg 141 1)
	    )


	  (if (inters #pmg #ihg #pmgg #ELP)	  
	      (progn		
		(grdraw #pmgg #ihg 141 1)
		(setq #SLP #ihg)
		(setq inter "HG")
	      )
	  )
	  (if (inters #pmg #ibg #pmgg #ELP)	  
	      (progn	
		(grdraw #pmgg #ibg 141 1)
		(setq #SLP #ibg)
		(setq inter "BG")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 141 1)
	  ))
           
      )
    
    ;;cot Droit
    (progn
      (setq inter "D")
      (setq #SLP #pmdd) 
      (if (eq Lstyle 0)
	  (progn
	    (if (not DrawBar)
	    (progn
	  (setq barrD (list #phd #pmd #pmdd #pmd #pbd ""))
	  (grdraw #pbd #phd 243 1)
	  ))
	  (grdraw #pmd #pmdd 243 1)
	  (if (inters #pmd #ihd #pmdd #ELP)
	      (progn		
		(grdraw #pmdd #ihd 243 1)		
		(setq #SLP #ihd)
		(setq inter "HD")
	      )	    
	  )
	  (if (inters #pmd #ibd #pmdd #ELP)
	      (progn		
		(grdraw #pmdd #ibd 243 1)		
		(setq #SLP #ibd)
		(setq inter "BD")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 243 1)
	  ))
      ;;MTEXT avec ACCOLADE
      (if (eq Lstyle 1)	  
	  (progn
	     (if (not DrawBar)
	    (progn
	  (setq #acc1a (polar #phd (angle #phg #phd) hdt))
	  (setq #acc1a (polar #acc1a (angle #phd #pbd) hdt))
	  (setq #acc2a (polar #acc1a (angle #phd #pbd) (- (/ (distance #phd #pbd) 2) (* hdt 2))))
	  (setq #acc2b (polar #acc2a (angle #phd #pbd) (* hdt 2)))
	  (setq #acc1b (polar #acc2b (angle #phd #pbd) (- (/ (distance #phd #pbd) 2) (* hdt 2))))
	  
	  (setq barrD (list #phd #acc1a #acc2a #pmdd #acc2b #acc1b #pbd ""))
	  (grdraw #phd #acc1a 23 1)
	  (grdraw #acc1a #acc2a 23 1)
	  (grdraw #acc2a #pmdd 23 1)
	  (grdraw #pmdd #acc2b 23 1)
	  (grdraw #acc2b #acc1b 23 1)
	  (grdraw #acc1b #pbd 23 1)
	  )
          (grdraw #pmd #pmdd 23 1)
	    )	  
	  
	  (if (inters #pmd #ihd #pmdd #ELP)
	      (progn		
		(grdraw #pmdd #ihd 23 1)
		(setq #SLP #ihd)
		(setq inter "HD")
	      )
	  )
	  (if (inters #pmd #ibd #pmdd #ELP)
	      (progn	
		(grdraw #pmdd #ibd 23 1)
		(setq #SLP #ibd)
		(setq inter "BD")
	      ) 	      
	  )	  
	  (grdraw #SLP #ELP 23 1)
	  ))
      )
    );_if

)))
  
  );_while
(setq pickmode (car grr));;25  right-clic   3 left-Clic
  
)





(defun createMTleader ()
  
;;cration de la barre gauche
(if (and  (< (distance #ELP #pmg)(distance #ELP #pmd))
	  (not barrGflag) (not DrawBar))  
 (progn
 (foreach n barrG (vl-cmdf "._pline"   n))
 (vl-cmdf "._chprop" (entlast) "" "_LA" tlay "_CO" dimclrd "")
 (setq barrGflag T)
 (TL_put_Text_Xdata (entlast) _Thandle (itoa  _Tjust))
 )
)


;;cration de la barre droite
(if (and (< (distance #ELP #pmd)(distance #ELP #pmg))
	 (not barrDflag) (not DrawBar))
 (progn
 (foreach n barrD (vl-cmdf "._pline"   n))
 (vl-cmdf "._chprop" (entlast) "" "_LA" tlay "_CO" dimclrd "")
 (setq barrDflag T)
 (TL_put_Text_Xdata (entlast) _Thandle (itoa  _Tjust))
 )
)


(if (not DrawBar)
  (progn  
(if (eq inter "G")(vl-cmdf "._Leader" #ELP #pmgg "_A" "" "_N"))
(if (eq inter "HG")(vl-cmdf "._Leader" #ELP #SLP #pmgg "_A" "" "_N"))
(if (eq inter "BG")(vl-cmdf "._Leader" #ELP #SLP #pmgg "_A" "" "_N"))
(if (eq inter "D")(vl-cmdf "._Leader" #ELP #pmdd "_A" "" "_N"))
(if (eq inter "HD")(vl-cmdf "._Leader" #ELP #SLP #pmdd "_A" "" "_N"))
(if (eq inter "BD")(vl-cmdf "._Leader" #ELP #SLP #pmdd "_A" "" "_N"))
(TL_put_Text_Xdata (entlast) _Thandle (itoa  _Tjust))
  )


  (progn
(if (eq inter "G")(vl-cmdf "._Leader" #ELP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "HG")(vl-cmdf "._Leader" #ELP #SLP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "BG")(vl-cmdf "._Leader" #ELP #SLP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "D")(vl-cmdf "._Leader" #ELP #pmdd #pmd "_A" "" "_N"))
(if (eq inter "HD")(vl-cmdf "._Leader" #ELP #SLP #pmdd #pmd "_A" "" "_N"))
(if (eq inter "BD")(vl-cmdf "._Leader" #ELP #SLP #pmdd #pmd "_A" "" "_N"))
(TL_put_Text_Xdata (entlast) _Thandle (itoa  _Tjust))
)
  )
(vl-cmdf "._chprop" (entlast) "" "_LA" tlay "_CO" dimclrd "")
(setq #ELP nil)
)










(defun createDTleader ()

(if (eq inter "G")(vl-cmdf "._Leader" #ELP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "HG")(vl-cmdf "._Leader" #ELP #SLP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "BG")(vl-cmdf "._Leader" #ELP #SLP #pmgg #pmg "_A" "" "_N"))
(if (eq inter "D")(vl-cmdf "._Leader" #ELP #pmdd #pmd "_A" "" "_N"))
(if (eq inter "HD")(vl-cmdf "._Leader" #ELP #SLP #pmdd #pmd "_A" "" "_N"))
(if (eq inter "BD")(vl-cmdf "._Leader" #ELP #SLP #pmdd #pmd "_A" "" "_N"))

(if (or (eq inter "HD")
	(eq inter "HG")
	(eq inter "BG")
	(eq inter "BD")
    )
(setq arrowp "3")
(setq arrowp "2")
)
  
;;Xdata pour Leader
(TL_put_Text_Xdata (entlast) _Thandle arrowp)
  
(vl-cmdf "._chprop" (entlast) "" "_LA" tlay "_CO" dimclrd "")
(setq #ELP nil)
)










;;			S T A R T
(defun c:Tleader2 ()  
  (Tleader2_go)  
)

(defun Tleader2_go ()
  (setq LineR nil
	LineL nil
     	ent_sel1 nil
	TEXTpL nil
	TEXTin nil)
  
  (setq dimclrd (getvar "DIMCLRD"))
  (if (eq dimclrd 256)
    (setq dimclrd "_BYLAYER")
  )
  (if (eq dimclrd 0)
    (setq dimclrd "_BYBLOCK")
  )

  
(setq allTXT (ssget "X" '((0 . "MTEXT,TEXT"))))
(if allTXT
  (progn
  (setq sscountxt (sslength allTXT))      
  (setq TvalL1 (- sscountxt 1))      
  (repeat sscountxt
    (setq TentL (entget (ssname allTXT TvalL1)))
    (setq TEXT10 (cdr (assoc 10 TentL)))
    (setq TEXT50 (cdr (assoc 50 TentL)))

(if  (eq (setq TEXT0 (cdr (assoc 0 TentL))) "TEXT")
  (progn
(setq Telong (car (cadr (textbox TentL))))
(setq Tehaut (cadr (cadr (textbox TentL))))

(setq pbox1 TEXT10)    
(setq pbox2 (polar TEXT10 TEXT50 Telong))
(setq pbox3 (polar pbox2 (- TEXT50 90) Tehaut))    
(setq pbox4 (polar TEXT10 (- TEXT50 180) Tehaut))
)
  (progn    
(setq hdt (/ (setq htt (cdr (assoc 40 TentL))) 2))	;Hauteur Du Texte / 2
(setq Telong (cdr (assoc 42 TentL)))			;Longueur Horizontale
(setq Tehaut (cdr (assoc 43 TentL)))			;Hauteur Verticale
(setq TinsMe (cdr (assoc 71 TentL)))			;Mthode d'insertion

;;Haut Gauche
(if (eq TinsMe 1)
    (setq pbox1 TEXT10)
)


;;Haut Centre
(if (eq TinsMe 2)
    (setq pbox1 (polar TEXT10 (- TEXT50 180) (/ Telong 2)))
)

;;Haut Droit
(if (eq TinsMe 3)
    (setq pbox1 (polar TEXT10 (- TEXT50 180) Telong))
)

;;Milieu Gauche
(if (eq TinsMe 4)
    (setq pbox1 (polar TEXT10 (+ TEXT50 90) (/ Tehaut 2)))
)

;;Milieu Centre
(if (eq TinsMe 5)
    (setq pbox1 (polar
		  (polar TEXT10 (+ TEXT50 90) (/ Tehaut 2))
		  (- TEXT50 180)
		  (/ Telong 2)
		)
    )
)

;;Milieu Droit
(if (eq TinsMe 6)
    (setq pbox1 (polar
		  (polar TEXT10 (+ TEXT50 90) (/ Tehaut 2))
		  (- TEXT50 180)
		  Telong
		)
    )
)

;;Bas Gauche
(if (eq TinsMe 7)
    (setq pbox1 (polar TEXT10 (+ TEXT50 90) Tehaut))
)

;;Bas centre
(if (eq TinsMe 8)
    (setq pbox1 (polar
		  (polar TEXT10 (+ TEXT50 90) Tehaut)
		  (- TEXT50 180)
		  (/ Telong 2)
		  )
		  
	  )
)

;;Bas Droit
(if (eq TinsMe 9)
    (setq pbox1 (polar
		  (polar TEXT10 (+ TEXT50 90) Tehaut)
		  (- TEXT50 180)
		  Telong
		  )
		  
	  )
)

(setq pbox3	(polar
		  (polar pbox1 TEXT50 Telong)
		  (- TEXT50 90)
		  Tehaut
		)
    )

);_progn
);_if
   

;;2009-09-10
(setq TEXTMC  (polar pbox1 (angle pbox1 pbox3) (/ (distance pbox1 pbox3) 2)))


    (setq TEXTpL (append TEXTpL (list TEXTMC)));(list pbox1 pbox2 pbox3 pbox4)))
    (setq TEXTin (append TEXTin (list TEXT10)))
    
    (setq TvalL1 (- TvalL1 1))
   )
  )
)



(if TEXTpL
  (progn
(setq VS2 (/ (getvar "VIEWSIZE") 30)) 
 (while (= (car (setq grr (grread T 4))) 5)

  (setq #ELP (car (cdr grr)))
  (foreach p TEXTpL
    (if (< (distance p #ELP) VS2)
      (progn
	(setq pt p)
(setq vlpo (vl-position p TEXTpL))	

(setq ent_sel1 (ssname (ssget "X" (list
			  '(0 . "MTEXT,TEXT")
		    	(cons 10  (nth vlpo TEXTin)))
		     )
		   0)
      )

;;ent_sel1 = (<Nom d'entit: 7efdc548> (59.3316 38.7619 0.0))

   
    (if ent_sel1
      (progn
	(setq ent_sel2 (entget ent_sel1))
	;(setq ent_sel2 (entget (car ent_sel1)))
	(setq spt_ent (cdr (assoc 0 ent_sel2)))
	(setq tlay (cdr (assoc 8 ent_sel2)))
	(if (and
	      (/= spt_ent "TEXT")
	      (/= spt_ent "MTEXT")
	    )
	  (setq ent_sel1 nil)
)))


;(setq Lstyle (getint "\n0 = Ligne, 1 = Accollade. Votre choix <0>:"))
  
  (if (not Lstyle)
    (setq Lstyle 0))

(if (or
      (eq spt_ent "TEXT")
      (eq spt_ent "MTEXT")
    )
    (if (eq spt_ent "TEXT") (go_run_text)
    	(go_run_mtext))
  )
)

      ))))))



(defun c:TLEADERCONFIG ()
(setq Lstyle (getint "\n0 = Ligne, 1 = Accollade. Votre choix <0>:"))
)  











(defun checkTLBlock ()

(setq TLT (car (cdr (ssgetfirst))))
(if (not TLT)
  (setq TLT (ssget "_P"))
)

;(vl-cmdf "_chprop" TLT "" "_C" "1" "")
(if TLT
    (progn
      (setq sscount (sslength TLT))      
      (setq val1 (- sscount 1))      
      (repeat sscount	
	(setq Tent (entget (ssname TLT val1)));;dtail de l'entit
	(setq Ta0  (cdr (assoc 0 Tent)))
	(if (or(eq Ta0 "TEXT")(eq Ta0 "MTEXT"))
	  (setq onlyTEXT T)
	  (progn
	    (setq onlyTEXT nil)
	    (setq sscount 0)
	  )
	  )
	(setq val1 (- val1 1))
	);_repeat
      


  (setq sscount (sslength TLT))      
      (setq val1 (- sscount 1))      
      (repeat sscount	
	(setq Tent (entget (ssname TLT val1)))	;;dtail de l'entit
	(setq Ta10 (cdr (assoc 10 Tent)))	;;point d'insertion
	(setq Ta05 (cdr (assoc 5 Tent)))	;;Handle
	
	(setq insT10 (vl-princ-to-string (list (rtos (nth 0 Ta10) 2 8)(rtos (nth 1 Ta10) 2 8))))	
	(setq xdT10 (TL_get_Text_Xdata (ssname TLT val1) "TLeader"));(item xdta)

	(if (and xdT10
		 (/= xdT10  insT10)
		 )	
	(progn
	    (setq nTDist (distance (read xdT10) (read insT10)))
	    (setq nTAngl (angle (read xdT10) (read insT10)))
	  
	  ;;Update leader
	  (if onlyTEXT
	    (TLeader_Update_Leader nTAngl nTDist Ta05)
	  )
	  
	  ;;Update Xdata Text
	    (TL_put_Text_Xdata (ssname TLT val1) "TLeader" insT10)


	);_progn
	);_if
	(setq val1 (- val1 1))
      );_repeat

      
      )
  )
)



  






	


;;(vlr-remove-all)
;;;
;;;(defun checkTLBlock_temp (/ xd1)
;;;
;;;  (setq TLT (ssget "X" '((0 . "MTEXT,TEXT")				
;;;			        (-3 ("TLeader"))
;;;			  )
;;;	))
;;;  (if TLT
;;;    (progn
;;;      (setq sscount (sslength TLT))      
;;;      (setq val1 (- sscount 1))      
;;;      (repeat sscount	
;;;	(setq Tent (entget (ssname TLT val1)));;dtail de l'entit
;;;	(setq Ta0  (cdr (assoc 0 Tent)))
;;;	(setq Ta10 (cdr (assoc 10 Tent)))
;;;	(setq Ta05 (cdr (assoc 5 Tent)))
;;;	(setq Ta41 (cdr (assoc 41 Tent)))
;;;	(setq Ta10L (vl-princ-to-string (list (rtos (nth 0 Ta10) 2 8)(rtos (nth 1 Ta10) 2 8))))
;;;	
;;;	(setq xd1 (TL_get_Text_Xdata (ssname TLT val1) "TLeader"));(item xdta)
;;;	
;;;	(if (and xd1
;;;		 (/= xd1  Ta10L)
;;;		 )
;;;	  (progn
;;;	    (setq nTDist (distance (read xd1) (read Ta10L)))
;;;	    (setq nTAngl (angle (read xd1) (read Ta10L)))
;;;	      (TLeader_Update_Leader Ta10)
;;;	    )
;;;	    )
;;;	(setq val1 (- val1 1))
;;;      )
;;;    )
;;;  )
;;;)





(defun TLeader_Update_Leader (xTangl xTDist xTa05)

;;Capture des leader ayant un XDATA
(setq TLL (ssget "X" (list
			     '(0 . "LEADER")
			     (cons -3 (list (list xTa05)))
)))  

;;si ca existe
(if TLL
  (progn
  (setq sscountL (sslength TLL))      
  (setq valL1 (- sscountL 1))      
  (repeat sscountL
    (setq entL (entget (ssname TLL valL1)))
    
;;si le leader contient du Xdata
(if (setq Lead#points (TL_get_Text_Xdata (ssname TLL valL1) xTa05))
  (progn
(setq nENTlist ())
(setq v 1)
(foreach n entL
  (if (eq (car n) 10)
    (progn
      (set (read (strcat "lp" (itoa v)))
	  (cons 10 (polar (cdr n) xTangl xTDist)))
      (setq v (1+ v))      
    )
  )
)
(setq lp1 (assoc 10 entL))


			
(setq v 1)
(setq n10List ())
(setq nENTlist ())
(foreach n entL
  (if (eq (car n) 10)      
    (progn
      (setq nENTlist (append nENTlist (list (eval (read (strcat "lp" (itoa v)))))))
      (setq v (1+ v))
    )
    (setq nENTlist (append nENTlist (list n)))
    )
)
(entmod nENTlist)
);_progn
);_if
(setq valL1 (- valL1 1))
);_repeat

  );_progn
  );_if



(setq TLL (ssget "X" (list
			     '(0 . "LINE,LWPOLYLINE")
			     (cons -3 (list (list xTa05)))
)))

(if TLL
  (progn  
  (setq sscountL (sslength TLL))      
      (setq valL1 (- sscountL 1))
(repeat sscountL
  (setq entL (entget (ssname TLL valL1)))
(setq nENTlist ())
(setq v 1)
(foreach n entL
  (if (eq (car n) 10)
    (progn
      (set (read (strcat "lp" (itoa v)))
	  (cons 10 (polar (cdr n) xTAngl xTDist)))
      (setq v (1+ v))      
    )
  )
)

(setq v 1)
(setq n10List ())
(setq nENTlist ())
(foreach n entL
  (if (eq (car n) 10)     
    (progn
      (setq nENTlist (append nENTlist (list (eval (read (strcat "lp" (itoa v)))))))
      (setq v (1+ v))
    )
    (setq nENTlist (append nENTlist (list n)))
    )
)
(entmod nENTlist)
(setq valL1 (- valL1 1))
);_repeat

)
  )

  )













;|						;
		REACTOR				;
						|;
 

(if TLMoveEnded
  (vlr-remove TLMoveEnded)
)


;;Start Reactor
(setq RTMoveEnded
       (vlr-command-reactor
	 nil
	 '((:vlr-commandEnded . *TLMoveEnded*))
       )
)

;;Reactor on ended MOVE
(defun *TLMoveEnded* (call-reactor scI /)
  (if (member (car sci) (list "MOVE" "STRETCH" "GRIP_MOVE" "GRIP_STRETCH"))
	      (checkTLBlock))
  
)




























(princ "\n\n    --  T L E A D E R 2 --		:Activ
Par: Andrea Andreetti")

















